﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;

namespace Train
{
    public static class CommunicationToInterface
    {
        private const string host = "localhost";
        private const int port = 5550;
        private static string SendMessage(string Message)
        {
            // String to store the response ASCII representation.
            String responseData = String.Empty;
            try
            {
                TcpClient client = new TcpClient(host, port);
                Byte[] data = System.Text.Encoding.ASCII.GetBytes(Message);
                NetworkStream stream = client.GetStream();
                // Send the message to the connected TcpServer. 
                stream.Write(data, 0, data.Length);
                // Buffer to store the response bytes.
                data = new Byte[256];
                // Read the first batch of the TcpServer response bytes.
                Int32 bytes = stream.Read(data, 0, data.Length);
                responseData = System.Text.Encoding.ASCII.GetString(data, 0, bytes);
                // Close everything.
                stream.Close();
                client.Close();
            }
            catch
            {
            }
            return responseData;
        }
        public static void AllOff()
        {
            string operation = "2180A1" + "\r\n";
            SendMessage(operation);
        }
        public static void AllOn()
        {
            string operation = "2181A0" + "\r\n";
            SendMessage(operation);
        }
        public static void Ligth(int Adress_Lenz, bool LigthOn)
        {
            string operation;
            //
            int LigthStatus = 0;
            if (LigthOn == true) LigthStatus = 1;
            //
            int adress_normal = Adress_Lenz - 1;
            int adress_range = adress_normal / 4;
            string adress_range_hex = General.DecToHex(adress_range);
            //
            int rest = adress_normal % 4;
            //
            int daten2_int = 128 + 8 + 2 * rest + LigthStatus;
            string daten2_Hex = General.DecToHex(daten2_int);
            //
            string XOR_Byte = General.CalculateXORByte(new int[] { 82, adress_range, daten2_int });

            //
            operation = "52" + adress_range_hex + daten2_Hex + XOR_Byte + "\r\n";
            SendMessage(operation);

        }
        public static void TrainStop(int Adress)
        {
            // die betreffende Lok wird auf dem Gleis sofort angehalten
            string operation;
            // Lokadresse berechnen
            int adressHight = 0;
            string adressHigth_Hex = General.DecToHex(adressHight);
            string adressLow_Hex = General.DecToHex(Adress);
            string XOR_Byte = General.CalculateXORByte(new int[] { 146, adressHight, Adress });
            //
            operation = "92" + adressHigth_Hex + adressLow_Hex + XOR_Byte + "\r\n";
            SendMessage(operation);
        }
        public static void TrainSpeed(int Adress, int Speed, bool Direction)
        {
            // Lokadresse berechnen
            int adressHight = 0;
            string adressHigth_Hex = General.DecToHex(adressHight);
            string adressLow_Hex = General.DecToHex(Adress);
            // Geschwindigkeit und Richtung zu einem Code auswerten

            int[] SpeedArray = new int[] {0, 2, 18, 3, 19, 4, 20, 5, 21, 6, 22, 7, 23, 8, 24, 9, 25, 10, 26, 11, 27, 12, 28, 13, 29, 14, 30, 15, 31 };

            int speed_Direction = SpeedArray[Speed];
            if (Direction == false) speed_Direction = speed_Direction + 128;
            string speed_Hex = General.DecToHex(speed_Direction);
            string XOR_Byte = General.CalculateXORByte(new int[] { 228, 18, adressHight, Adress, speed_Direction });
            //
            string operation = "E4" + "12" + adressHigth_Hex + adressLow_Hex + speed_Hex + XOR_Byte + "\r\n";
            SendMessage(operation);
        }
        public static void LigthOnTrain(int Adress, bool Status)
        {
            // Lokadresse berechnen
            int adressHight = 0;
            string adressHigth_Hex = General.DecToHex(adressHight);
            string adressLow_Hex = General.DecToHex(Adress);
            //
            int daten3;
            if (Status == true) daten3 = 16;
            else daten3 = 0;
            string daten3_Hex = General.DecToHex(daten3);
            String XOR_Byte = General.CalculateXORByte(new int[] { 228, 32, adressHight, Adress, daten3 });
            string operation = "E4" + "20" + adressHigth_Hex + adressLow_Hex + daten3_Hex + XOR_Byte + "\r\n";
            SendMessage(operation);
        }
    }
}
