﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Controls.Primitives;

namespace Train
{
    /// <summary>
    /// Interaction logic for ConfigurationPlan.xaml
    /// </summary>
    public partial class ConfigurationPlan : Window
    {
        private Data data;
        public enum Modus { Draw, Configuation, Test };
        public Modus FormModus;
        public ConfigurationPlan()
        {
            InitializeComponent();
            FormModus = Modus.Draw;
        }
        public void ShowFormAndInput(Data Daten)
        {
            data = Daten;
            ShowDialog();
        }
        private Point mousePosition;
        private string standardElementName = "Line1";
        private void canvas_MouseDown(object sender, MouseButtonEventArgs e)
        {
            mousePosition = e.GetPosition(canvas);
            if (FormModus == Modus.Draw)
            {
                if ((e.LeftButton == MouseButtonState.Pressed) && (e.ClickCount == 2))
                {
                    CreateElement(standardElementName);
                }
            }
            else if (FormModus == Modus.Configuation)
            {
                // Typ des Elementes ermitteln
                Point position = GetNormalizedMousePosition();
                foreach (var item in canvas.Children)
                {
                    Point elementPosition = new Point(Canvas.GetLeft((UIElement)item), Canvas.GetTop((UIElement)item));
                    if (Point.Equals(position, elementPosition) == true)
                    {
                        // je nach Typ des Elements....
                        if (item is Swicht)
                        {
                            // Auswahl des Weiche aus der Liste
                        }
                    }
                }
            }
            else
            {
                // Typ des Elementes ermitteln
                Point position = GetNormalizedMousePosition();
                foreach (var item in canvas.Children)
                {
                    Point elementPosition = new Point(Canvas.GetLeft((UIElement)item), Canvas.GetTop((UIElement)item));
                    if (Point.Equals(position, elementPosition) == true)
                    {
                        // je nach Typ des Elements....
                        if (item is Swicht)
                        {
                            Swicht s = (Swicht)item;
                            if (s.Status == Swicht.SwichtStatus.left)
                            {
                                s.Status = Swicht.SwichtStatus.right;
                                s.Template = (ControlTemplate)this.TryFindResource(s.TemplateName + "b");
                            }
                            else
                            {
                                s.Status = Swicht.SwichtStatus.left;
                                s.Template = (ControlTemplate)this.TryFindResource(s.TemplateName + "a");

                            }
                        }
                    }
                }
            }
        }
        private Point GetNormalizedMousePosition()
        {
            int row = (int)mousePosition.X / 50;
            int col = (int)mousePosition.Y / 50;
            return new Point(50 * row, 50 * col);
        }
        private void CreateElement(string ElementName)
        {
            DeleteElementOnCurrentPosition();
            Point position = GetNormalizedMousePosition();
            Element element = new Element();
            element.Template = (ControlTemplate)this.TryFindResource(ElementName);
            element.TemplateName = ElementName;
            Canvas.SetLeft(element, position.X);
            Canvas.SetTop(element, position.Y);
            canvas.Children.Add(element);
        }     
        private void CreateSwitch(string ElementName)
        {
            DeleteElementOnCurrentPosition();
            Point position = GetNormalizedMousePosition();
            Swicht s = new Swicht();
            s.Template = (ControlTemplate)this.TryFindResource(ElementName+"a");
            s.TemplateName = ElementName;
            Canvas.SetLeft(s, position.X);
            Canvas.SetTop(s, position.Y);
            canvas.Children.Add(s);
        }
        private void DeleteElementOnCurrentPosition()
        {
            Point position = GetNormalizedMousePosition();
            foreach (var item in canvas.Children)
            {
                Point elementPosition = new Point(Canvas.GetLeft((UIElement)item), Canvas.GetTop((UIElement)item));
                if (Point.Equals(position, elementPosition) == true)
                {
                    canvas.Children.Remove((ContentControl)item);
                    break;
                }
            }
        }
        private void menuItemElement_Click(object sender, RoutedEventArgs e)
        {
            standardElementName = ((MenuItem)sender).Tag.ToString();
            CreateElement(standardElementName);
        }
        private void menuItemSwitch_Click(object sender, RoutedEventArgs e)
        {
            string elementName = ((MenuItem)sender).Tag.ToString();
            CreateSwitch(elementName);
        }
        private void MenuItemDelete_Click(object sender, RoutedEventArgs e)
        {
            DeleteElementOnCurrentPosition();
        }
        private void RadioButton_Click(object sender, RoutedEventArgs e)
        {
            FormModus = Modus.Draw;
            canvas.ContextMenu = ContextMenue1;
            canvas.Background = new SolidColorBrush(Colors.LightBlue);
        }
        private void RadioButton_Click_1(object sender, RoutedEventArgs e)
        {
            FormModus = Modus.Configuation;
            canvas.ContextMenu = null;
            canvas.Background = new SolidColorBrush(Colors.LightYellow);
        }
        private void RadioButton_Click_2(object sender, RoutedEventArgs e)
        {
            FormModus = Modus.Test;
            canvas.ContextMenu = null;
            canvas.Background = new SolidColorBrush(Colors.LightGreen);
        }
 
    }
}
